// File:Student.java
// Student Class Definition

import java.io.*;

public class Student {

  private String Name, Address, Phone;   // Object names capitalized
  private int id, hours;                 // Simple types lower case
  private double gpa;

 // Default Constructor
 public Student()
 {Name=Address=Phone="";
  id=hours=0;
  gpa=0.0;
 }

 // Constructor with Name argument
 public Student(String StudentName, String StudentAddress, String StudentPhone)
 {Name=StudentName;
  Address=StudentAddress;
  Phone=StudentPhone;
  id=hours=0;
  gpa=0.0;
 }

 // Initialize Name of Student
 public void setName(String StudentName)
 {Name=StudentName;}

 // Get Hours Completed
 public int hoursCompleted()
 {return(hours);}

 // Get Student's Name
 public String getName()
 {return (Name);
 }

 public void readDataFromStream(BufferedReader Infile) throws java.io.IOException
 {Name=Infile.readLine();
  Address=Infile.readLine();
  Phone=Infile.readLine();
  gpa=Double.valueOf(Infile.readLine()).doubleValue();
  id=Integer.valueOf(Infile.readLine()).intValue();
  hours=Integer.valueOf(Infile.readLine()).intValue();
 }

 double getGPA()
 {return(gpa);}

 // Print Student Info
 public void printStudentInfo() throws java.io.IOException
 {System.out.println(Name+"\n"+Address+"\n"+Phone+"\nStudent ID:"+id+
                                "  Hours:"+hours+"   GPA:"+gpa+"\n");
 }

 public static void main(String args[]) throws java.io.IOException
 { File InputFile=new File("Students.txt");
  // Now, open a stream from the input file
  BufferedReader DataInput=
                         new BufferedReader(new FileReader(InputFile));
  Student S1, S2, S3;
  S1=new Student();
  S1.readDataFromStream(DataInput);
  S2=new Student();
  S2.readDataFromStream(DataInput);
  S3=new Student();
  S3.readDataFromStream(DataInput);
  S1.printStudentInfo();
  S2.printStudentInfo();
  S3.printStudentInfo();
  int h1=S1.hoursCompleted(),h2=S2.hoursCompleted(),h3=S3.hoursCompleted();
  System.out.println("\nTotal Credits:"+(h1+h2+h3));
  double avg=(S1.getGPA()*h1+S2.getGPA()*h2+S3.getGPA()*h3)/(h1+h2+h3);
  System.out.println("Weighted Average GPA:"+avg);
 }
}
